# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to
[Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

## [0.9.0] - 2023-10-25

- Upgrade to Telescope 1.0. This changes a lot of fields from optional to
  non-optional by utilizing the `(gogoproto.nullable) = false` annotations of
  proto files. See https://github.com/osmosis-labs/telescope/issues/386
- Switch to bigint for 64 bit integers. This means users can remove the
  `"long": "^4.0.0"` dependency in most cases.
- Remove runtime dependency `protobufjs` which is not required anymore by the
  latest version of code generated by Telescope 👏. ([#78])

[#78]: https://github.com/confio/cosmjs-types/issues/78

## [0.8.0] - 2023-05-24

- Upgrade Cosmos SDK types to 0.47.2 including new modules like group and NFT.
- Upgrade ibc-go types to v7.
- Upgrade to Telescope 0.94.1

## [0.7.2] - 2023-04-03

- Upgrade Cosmos SDK types to 0.45.15
- Upgrade wasmd types to 0.31.0

## [0.7.1] - 2023-03-07

- Fix missing proofs module

## [0.7.0] - 2023-03-07

- Upgrade Cosmos SDK types to 0.45.14 ([#57])
- Upgrade wasmd types to 0.30.0 and add ibc-go 4.2 as a separate submodule
  ([#58])

[#57]: https://github.com/confio/cosmjs-types/pull/57
[#58]: https://github.com/confio/cosmjs-types/pull/58

## [0.6.1] - 2022-12-22

### Changed

- Bring back fromJSON/toJSON ([#55])

[#55]: https://github.com/confio/cosmjs-types/pull/55

## [0.6.0] - 2022-12-08

### Changed

- Code generation was migrated from ts-proto to
  [telescope](https://github.com/osmosis-labs/telescope) (#44). This gives us
  faster and better Cosmos specific code generation. This might come with minor
  breaking changes in the 0.6 release series. Feel free to stick to 0.5.x until
  the end of 2022. Then all potential issues should be fixed.
- Some common types are now exported at the package root. E.g.
  `import { DeepPartial } from "cosmjs-types"`.
- `fromJSON`/`toJSON` are not generated anymore. They were never needed for
  CosmJS and do not produce a Cosmos SDK compatible JSON.
- The TypeScript build target is now ES2020,
  [analogue to CosmJS 0.30](https://github.com/cosmos/cosmjs/issues/1002).

## [0.5.2] - 2022-10-11

- Migrate from yarn to npm
- Upgrade ts-proto to 1.126.1 and regenerate code
- Upgrade Cosmos SDK protos to 0.45.8
- Upgrade wasmd protos to 0.28.0
- Add ibc.applications.interchain_accounts types ([#36])

[#36]: https://github.com/confio/cosmjs-types/issues/36

## [0.5.1]

No changelog, sorry. Maybe the diff helps.

## [0.5.0]

No changelog, sorry. Maybe the diff helps.

## [0.4.1]

No changelog, sorry. Maybe the diff helps.

## [0.4.0]

No changelog, sorry. Maybe the diff helps.

## [0.3.0]

No changelog, sorry. Maybe the diff helps.

## [0.2.0] - 2021-07-29

### Added

- wasmd 0.18 types (cosmwasm/wasm/v1/\*)

[unreleased]: https://github.com/confio/cosmjs-types/compare/v0.9.0...HEAD
[0.9.0]: https://github.com/confio/cosmjs-types/compare/v0.8.0...v0.9.0
[0.8.0]: https://github.com/confio/cosmjs-types/compare/v0.7.2...v0.8.0
[0.7.2]: https://github.com/confio/cosmjs-types/compare/v0.7.1...v0.7.2
[0.7.1]: https://github.com/confio/cosmjs-types/compare/v0.7.0...v0.7.1
[0.7.0]: https://github.com/confio/cosmjs-types/compare/v0.6.1...v0.7.0
[0.6.1]: https://github.com/confio/cosmjs-types/compare/v0.6.0...v0.6.1
[0.6.0]: https://github.com/confio/cosmjs-types/compare/v0.5.2...v0.6.0
[0.5.2]: https://github.com/confio/cosmjs-types/compare/v0.5.1...v0.5.2
[0.5.1]: https://github.com/confio/cosmjs-types/compare/v0.5.0...v0.5.1
[0.5.0]: https://github.com/confio/cosmjs-types/compare/v0.4.1...v0.5.0
[0.4.1]: https://github.com/confio/cosmjs-types/compare/v0.4.0...v0.4.1
[0.4.0]: https://github.com/confio/cosmjs-types/compare/v0.3.0...v0.4.0
[0.3.0]: https://github.com/confio/cosmjs-types/compare/v0.2.0...v0.3.0
[0.2.0]: https://github.com/confio/cosmjs-types/compare/v0.1.0...v0.2.0
