import { FileDescriptorProto } from "../../../google/protobuf/descriptor";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { Rpc } from "../../../helpers";
export declare const protobufPackage = "cosmos.reflection.v1";
/** FileDescriptorsRequest is the Query/FileDescriptors request type. */
export interface FileDescriptorsRequest {
}
/** FileDescriptorsResponse is the Query/FileDescriptors response type. */
export interface FileDescriptorsResponse {
    /** files is the file descriptors. */
    files: FileDescriptorProto[];
}
export declare const FileDescriptorsRequest: {
    typeUrl: string;
    encode(_: FileDescriptorsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): FileDescriptorsRequest;
    fromJSON(_: any): FileDescriptorsRequest;
    toJSON(_: FileDescriptorsRequest): unknown;
    fromPartial<I extends {} & {} & Record<Exclude<keyof I, never>, never>>(_: I): FileDescriptorsRequest;
};
export declare const FileDescriptorsResponse: {
    typeUrl: string;
    encode(message: FileDescriptorsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): FileDescriptorsResponse;
    fromJSON(object: any): FileDescriptorsResponse;
    toJSON(message: FileDescriptorsResponse): unknown;
    fromPartial<I extends {
        files?: {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: import("../../../google/protobuf/descriptor").FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[] | undefined;
    } & {
        files?: ({
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: import("../../../google/protobuf/descriptor").FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[] & ({
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: import("../../../google/protobuf/descriptor").FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        } & {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["dependency"], keyof string[]>, never>) | undefined;
            publicDependency?: (number[] & number[] & Record<Exclude<keyof I["files"][number]["publicDependency"], keyof number[]>, never>) | undefined;
            weakDependency?: (number[] & number[] & Record<Exclude<keyof I["files"][number]["weakDependency"], keyof number[]>, never>) | undefined;
            messageType?: ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                field?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["field"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["field"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                extension?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["extension"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                nestedType?: ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    field?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["field"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    extension?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extension"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    nestedType?: ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        field?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        extension?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        nestedType?: ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            field?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            extension?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            nestedType?: ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                field?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                extension?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                nestedType?: ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    field?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    extension?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    nestedType?: ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        field?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        extension?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        nestedType?: ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            field?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            extension?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            nestedType?: ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                field?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                extension?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                nestedType?: ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>, never>) | undefined;
                                                enumType?: ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>, never>) | undefined;
                                                extensionRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                oneofDecl?: ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                options?: ({
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>, never>) | undefined;
                                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>, never>) | undefined;
                                            enumType?: ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                value?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                options?: ({
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>, never>) | undefined;
                                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>, never>) | undefined;
                                            extensionRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            oneofDecl?: ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            options?: ({
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>, never>) | undefined;
                                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>, never>) | undefined;
                                        enumType?: ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            value?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: ({
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumValueOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            options?: ({
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>, never>) | undefined;
                                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>, never>) | undefined;
                                        extensionRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        oneofDecl?: ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        options?: ({
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>, never>) | undefined;
                                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>, never>) | undefined;
                                    enumType?: ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        value?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: ({
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumValueOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        options?: ({
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>, never>) | undefined;
                                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>, never>) | undefined;
                                    extensionRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    oneofDecl?: ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    options?: ({
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>, never>) | undefined;
                                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>, never>) | undefined;
                                enumType?: ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    value?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: ({
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumValueOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    options?: ({
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>, never>) | undefined;
                                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>, never>) | undefined;
                                extensionRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                oneofDecl?: ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                options?: ({
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>, never>) | undefined;
                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>, never>) | undefined;
                            enumType?: ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                value?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: ({
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumValueOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                options?: ({
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>, never>) | undefined;
                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>, never>) | undefined;
                            extensionRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            oneofDecl?: ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            options?: ({
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>, never>) | undefined;
                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>, never>) | undefined;
                        enumType?: ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            value?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: ({
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumValueOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            options?: ({
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>, never>) | undefined;
                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>, never>) | undefined;
                        extensionRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        oneofDecl?: ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        options?: ({
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>, never>) | undefined;
                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["nestedType"], keyof {
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                            type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>, never>) | undefined;
                    enumType?: ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        value?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: ({
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumValueOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        options?: ({
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>, never>) | undefined;
                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["enumType"], keyof {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>, never>) | undefined;
                    extensionRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["extensionRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    oneofDecl?: ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["oneofDecl"], keyof {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    options?: ({
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>, never>) | undefined;
                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["nestedType"], keyof {
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                        type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>, never>) | undefined;
                enumType?: ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    value?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: ({
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["value"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumValueOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["value"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    options?: ({
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>, never>) | undefined;
                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["enumType"], keyof {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>, never>) | undefined;
                extensionRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["extensionRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["extensionRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                oneofDecl?: ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["files"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["oneofDecl"][number], keyof import("../../../google/protobuf/descriptor").OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["oneofDecl"], keyof {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["files"][number]["messageType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["files"][number]["messageType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["options"], keyof import("../../../google/protobuf/descriptor").MessageOptions>, never>) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & Record<Exclude<keyof I["files"][number]["messageType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>, never>) | undefined;
                reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["messageType"][number]["reservedName"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["files"][number]["messageType"][number], keyof import("../../../google/protobuf/descriptor").DescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["messageType"], keyof {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>, never>) | undefined;
            enumType?: ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                value?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["files"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["files"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["enumType"][number]["value"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumValueOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["enumType"][number]["value"][number], keyof import("../../../google/protobuf/descriptor").EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["enumType"][number]["value"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["files"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["files"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["enumType"][number]["options"], keyof import("../../../google/protobuf/descriptor").EnumOptions>, never>) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & Record<Exclude<keyof I["files"][number]["enumType"][number]["reservedRange"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["files"][number]["enumType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>, never>) | undefined;
                reservedName?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["files"][number]["enumType"][number], keyof import("../../../google/protobuf/descriptor").EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["enumType"], keyof {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>, never>) | undefined;
            service?: ({
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                method?: ({
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["files"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["files"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["files"][number]["service"][number]["method"][number]["options"], keyof import("../../../google/protobuf/descriptor").MethodOptions>, never>) | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                } & Record<Exclude<keyof I["files"][number]["service"][number]["method"][number], keyof import("../../../google/protobuf/descriptor").MethodDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["service"][number]["method"], keyof {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["files"][number]["service"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["service"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["files"][number]["service"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["service"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["service"][number]["options"], keyof import("../../../google/protobuf/descriptor").ServiceOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["files"][number]["service"][number], keyof import("../../../google/protobuf/descriptor").ServiceDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["service"], keyof {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            extension?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["files"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["files"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["extension"][number]["options"], keyof import("../../../google/protobuf/descriptor").FieldOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["files"][number]["extension"][number], keyof import("../../../google/protobuf/descriptor").FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"][number]["extension"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            options?: ({
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: import("../../../google/protobuf/descriptor").FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: import("../../../google/protobuf/descriptor").FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["files"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["files"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["files"][number]["options"]["uninterpretedOption"][number], keyof import("../../../google/protobuf/descriptor").UninterpretedOption>, never>)[] & Record<Exclude<keyof I["files"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["files"][number]["options"], keyof import("../../../google/protobuf/descriptor").FileOptions>, never>) | undefined;
            sourceCodeInfo?: ({
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } & {
                location?: ({
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] & ({
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                } & {
                    path?: (number[] & number[] & Record<Exclude<keyof I["files"][number]["sourceCodeInfo"]["location"][number]["path"], keyof number[]>, never>) | undefined;
                    span?: (number[] & number[] & Record<Exclude<keyof I["files"][number]["sourceCodeInfo"]["location"][number]["span"], keyof number[]>, never>) | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: (string[] & string[] & Record<Exclude<keyof I["files"][number]["sourceCodeInfo"]["location"][number]["leadingDetachedComments"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["files"][number]["sourceCodeInfo"]["location"][number], keyof import("../../../google/protobuf/descriptor").SourceCodeInfo_Location>, never>)[] & Record<Exclude<keyof I["files"][number]["sourceCodeInfo"]["location"], keyof {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["files"][number]["sourceCodeInfo"], "location">, never>) | undefined;
            syntax?: string | undefined;
        } & Record<Exclude<keyof I["files"][number], keyof FileDescriptorProto>, never>)[] & Record<Exclude<keyof I["files"], keyof {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                    type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: import("../../../google/protobuf/descriptor").MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Label | undefined;
                type?: import("../../../google/protobuf/descriptor").FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: import("../../../google/protobuf/descriptor").FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: import("../../../google/protobuf/descriptor").FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: import("../../../google/protobuf/descriptor").FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, "files">, never>>(object: I): FileDescriptorsResponse;
};
/** Package cosmos.reflection.v1 provides support for inspecting protobuf
 file descriptors. */
export interface ReflectionService {
    /**
     * FileDescriptors queries all the file descriptors in the app in order
     * to enable easier generation of dynamic clients.
     */
    FileDescriptors(request?: FileDescriptorsRequest): Promise<FileDescriptorsResponse>;
}
export declare class ReflectionServiceClientImpl implements ReflectionService {
    private readonly rpc;
    constructor(rpc: Rpc);
    FileDescriptors(request?: FileDescriptorsRequest): Promise<FileDescriptorsResponse>;
}
