import { BinaryReader, BinaryWriter } from "../../binary";
export declare const protobufPackage = "google.protobuf";
export declare enum FieldDescriptorProto_Type {
    /**
     * TYPE_DOUBLE - 0 is reserved for errors.
     * Order is weird for historical reasons.
     */
    TYPE_DOUBLE = 1,
    TYPE_FLOAT = 2,
    /**
     * TYPE_INT64 - Not ZigZag encoded.  Negative numbers take 10 bytes.  Use TYPE_SINT64 if
     * negative values are likely.
     */
    TYPE_INT64 = 3,
    TYPE_UINT64 = 4,
    /**
     * TYPE_INT32 - Not ZigZag encoded.  Negative numbers take 10 bytes.  Use TYPE_SINT32 if
     * negative values are likely.
     */
    TYPE_INT32 = 5,
    TYPE_FIXED64 = 6,
    TYPE_FIXED32 = 7,
    TYPE_BOOL = 8,
    TYPE_STRING = 9,
    /**
     * TYPE_GROUP - Tag-delimited aggregate.
     * Group type is deprecated and not supported in proto3. However, Proto3
     * implementations should still be able to parse the group wire format and
     * treat group fields as unknown fields.
     */
    TYPE_GROUP = 10,
    TYPE_MESSAGE = 11,
    /** TYPE_BYTES - New in version 2. */
    TYPE_BYTES = 12,
    TYPE_UINT32 = 13,
    TYPE_ENUM = 14,
    TYPE_SFIXED32 = 15,
    TYPE_SFIXED64 = 16,
    /** TYPE_SINT32 - Uses ZigZag encoding. */
    TYPE_SINT32 = 17,
    /** TYPE_SINT64 - Uses ZigZag encoding. */
    TYPE_SINT64 = 18,
    UNRECOGNIZED = -1
}
export declare function fieldDescriptorProto_TypeFromJSON(object: any): FieldDescriptorProto_Type;
export declare function fieldDescriptorProto_TypeToJSON(object: FieldDescriptorProto_Type): string;
export declare enum FieldDescriptorProto_Label {
    /** LABEL_OPTIONAL - 0 is reserved for errors */
    LABEL_OPTIONAL = 1,
    LABEL_REQUIRED = 2,
    LABEL_REPEATED = 3,
    UNRECOGNIZED = -1
}
export declare function fieldDescriptorProto_LabelFromJSON(object: any): FieldDescriptorProto_Label;
export declare function fieldDescriptorProto_LabelToJSON(object: FieldDescriptorProto_Label): string;
/** Generated classes can be optimized for speed or code size. */
export declare enum FileOptions_OptimizeMode {
    /**
     * SPEED - Generate complete code for parsing, serialization,
     * etc.
     */
    SPEED = 1,
    /** CODE_SIZE - Use ReflectionOps to implement these methods. */
    CODE_SIZE = 2,
    /** LITE_RUNTIME - Generate code using MessageLite and the lite runtime. */
    LITE_RUNTIME = 3,
    UNRECOGNIZED = -1
}
export declare function fileOptions_OptimizeModeFromJSON(object: any): FileOptions_OptimizeMode;
export declare function fileOptions_OptimizeModeToJSON(object: FileOptions_OptimizeMode): string;
export declare enum FieldOptions_CType {
    /** STRING - Default mode. */
    STRING = 0,
    CORD = 1,
    STRING_PIECE = 2,
    UNRECOGNIZED = -1
}
export declare function fieldOptions_CTypeFromJSON(object: any): FieldOptions_CType;
export declare function fieldOptions_CTypeToJSON(object: FieldOptions_CType): string;
export declare enum FieldOptions_JSType {
    /** JS_NORMAL - Use the default type. */
    JS_NORMAL = 0,
    /** JS_STRING - Use JavaScript strings. */
    JS_STRING = 1,
    /** JS_NUMBER - Use JavaScript numbers. */
    JS_NUMBER = 2,
    UNRECOGNIZED = -1
}
export declare function fieldOptions_JSTypeFromJSON(object: any): FieldOptions_JSType;
export declare function fieldOptions_JSTypeToJSON(object: FieldOptions_JSType): string;
/**
 * Is this method side-effect-free (or safe in HTTP parlance), or idempotent,
 * or neither? HTTP based RPC implementation may choose GET verb for safe
 * methods, and PUT verb for idempotent methods instead of the default POST.
 */
export declare enum MethodOptions_IdempotencyLevel {
    IDEMPOTENCY_UNKNOWN = 0,
    /** NO_SIDE_EFFECTS - implies idempotent */
    NO_SIDE_EFFECTS = 1,
    /** IDEMPOTENT - idempotent, but may have side effects */
    IDEMPOTENT = 2,
    UNRECOGNIZED = -1
}
export declare function methodOptions_IdempotencyLevelFromJSON(object: any): MethodOptions_IdempotencyLevel;
export declare function methodOptions_IdempotencyLevelToJSON(object: MethodOptions_IdempotencyLevel): string;
/**
 * The protocol compiler can output a FileDescriptorSet containing the .proto
 * files it parses.
 */
export interface FileDescriptorSet {
    file: FileDescriptorProto[];
}
/** Describes a complete .proto file. */
export interface FileDescriptorProto {
    /** file name, relative to root of source tree */
    name: string;
    package: string;
    /** Names of files imported by this file. */
    dependency: string[];
    /** Indexes of the public imported files in the dependency list above. */
    publicDependency: number[];
    /**
     * Indexes of the weak imported files in the dependency list.
     * For Google-internal migration only. Do not use.
     */
    weakDependency: number[];
    /** All top-level definitions in this file. */
    messageType: DescriptorProto[];
    enumType: EnumDescriptorProto[];
    service: ServiceDescriptorProto[];
    extension: FieldDescriptorProto[];
    options?: FileOptions;
    /**
     * This field contains optional information about the original source code.
     * You may safely remove this entire field without harming runtime
     * functionality of the descriptors -- the information is needed only by
     * development tools.
     */
    sourceCodeInfo?: SourceCodeInfo;
    /**
     * The syntax of the proto file.
     * The supported values are "proto2" and "proto3".
     */
    syntax: string;
}
/** Describes a message type. */
export interface DescriptorProto {
    name: string;
    field: FieldDescriptorProto[];
    extension: FieldDescriptorProto[];
    nestedType: DescriptorProto[];
    enumType: EnumDescriptorProto[];
    extensionRange: DescriptorProto_ExtensionRange[];
    oneofDecl: OneofDescriptorProto[];
    options?: MessageOptions;
    reservedRange: DescriptorProto_ReservedRange[];
    /**
     * Reserved field names, which may not be used by fields in the same message.
     * A given name may only be reserved once.
     */
    reservedName: string[];
}
export interface DescriptorProto_ExtensionRange {
    /** Inclusive. */
    start: number;
    /** Exclusive. */
    end: number;
    options?: ExtensionRangeOptions;
}
/**
 * Range of reserved tag numbers. Reserved tag numbers may not be used by
 * fields or extension ranges in the same message. Reserved ranges may
 * not overlap.
 */
export interface DescriptorProto_ReservedRange {
    /** Inclusive. */
    start: number;
    /** Exclusive. */
    end: number;
}
export interface ExtensionRangeOptions {
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
/** Describes a field within a message. */
export interface FieldDescriptorProto {
    name: string;
    number: number;
    label: FieldDescriptorProto_Label;
    /**
     * If type_name is set, this need not be set.  If both this and type_name
     * are set, this must be one of TYPE_ENUM, TYPE_MESSAGE or TYPE_GROUP.
     */
    type: FieldDescriptorProto_Type;
    /**
     * For message and enum types, this is the name of the type.  If the name
     * starts with a '.', it is fully-qualified.  Otherwise, C++-like scoping
     * rules are used to find the type (i.e. first the nested types within this
     * message are searched, then within the parent, on up to the root
     * namespace).
     */
    typeName: string;
    /**
     * For extensions, this is the name of the type being extended.  It is
     * resolved in the same manner as type_name.
     */
    extendee: string;
    /**
     * For numeric types, contains the original text representation of the value.
     * For booleans, "true" or "false".
     * For strings, contains the default text contents (not escaped in any way).
     * For bytes, contains the C escaped value.  All bytes >= 128 are escaped.
     * TODO(kenton):  Base-64 encode?
     */
    defaultValue: string;
    /**
     * If set, gives the index of a oneof in the containing type's oneof_decl
     * list.  This field is a member of that oneof.
     */
    oneofIndex: number;
    /**
     * JSON name of this field. The value is set by protocol compiler. If the
     * user has set a "json_name" option on this field, that option's value
     * will be used. Otherwise, it's deduced from the field's name by converting
     * it to camelCase.
     */
    jsonName: string;
    options?: FieldOptions;
}
/** Describes a oneof. */
export interface OneofDescriptorProto {
    name: string;
    options?: OneofOptions;
}
/** Describes an enum type. */
export interface EnumDescriptorProto {
    name: string;
    value: EnumValueDescriptorProto[];
    options?: EnumOptions;
    /**
     * Range of reserved numeric values. Reserved numeric values may not be used
     * by enum values in the same enum declaration. Reserved ranges may not
     * overlap.
     */
    reservedRange: EnumDescriptorProto_EnumReservedRange[];
    /**
     * Reserved enum value names, which may not be reused. A given name may only
     * be reserved once.
     */
    reservedName: string[];
}
/**
 * Range of reserved numeric values. Reserved values may not be used by
 * entries in the same enum. Reserved ranges may not overlap.
 *
 * Note that this is distinct from DescriptorProto.ReservedRange in that it
 * is inclusive such that it can appropriately represent the entire int32
 * domain.
 */
export interface EnumDescriptorProto_EnumReservedRange {
    /** Inclusive. */
    start: number;
    /** Inclusive. */
    end: number;
}
/** Describes a value within an enum. */
export interface EnumValueDescriptorProto {
    name: string;
    number: number;
    options?: EnumValueOptions;
}
/** Describes a service. */
export interface ServiceDescriptorProto {
    name: string;
    method: MethodDescriptorProto[];
    options?: ServiceOptions;
}
/** Describes a method of a service. */
export interface MethodDescriptorProto {
    name: string;
    /**
     * Input and output type names.  These are resolved in the same way as
     * FieldDescriptorProto.type_name, but must refer to a message type.
     */
    inputType: string;
    outputType: string;
    options?: MethodOptions;
    /** Identifies if client streams multiple client messages */
    clientStreaming: boolean;
    /** Identifies if server streams multiple server messages */
    serverStreaming: boolean;
}
export interface FileOptions {
    /**
     * Sets the Java package where classes generated from this .proto will be
     * placed.  By default, the proto package is used, but this is often
     * inappropriate because proto packages do not normally start with backwards
     * domain names.
     */
    javaPackage: string;
    /**
     * If set, all the classes from the .proto file are wrapped in a single
     * outer class with the given name.  This applies to both Proto1
     * (equivalent to the old "--one_java_file" option) and Proto2 (where
     * a .proto always translates to a single class, but you may want to
     * explicitly choose the class name).
     */
    javaOuterClassname: string;
    /**
     * If set true, then the Java code generator will generate a separate .java
     * file for each top-level message, enum, and service defined in the .proto
     * file.  Thus, these types will *not* be nested inside the outer class
     * named by java_outer_classname.  However, the outer class will still be
     * generated to contain the file's getDescriptor() method as well as any
     * top-level extensions defined in the file.
     */
    javaMultipleFiles: boolean;
    /** This option does nothing. */
    /** @deprecated */
    javaGenerateEqualsAndHash: boolean;
    /**
     * If set true, then the Java2 code generator will generate code that
     * throws an exception whenever an attempt is made to assign a non-UTF-8
     * byte sequence to a string field.
     * Message reflection will do the same.
     * However, an extension field still accepts non-UTF-8 byte sequences.
     * This option has no effect on when used with the lite runtime.
     */
    javaStringCheckUtf8: boolean;
    optimizeFor: FileOptions_OptimizeMode;
    /**
     * Sets the Go package where structs generated from this .proto will be
     * placed. If omitted, the Go package will be derived from the following:
     *   - The basename of the package import path, if provided.
     *   - Otherwise, the package statement in the .proto file, if present.
     *   - Otherwise, the basename of the .proto file, without extension.
     */
    goPackage: string;
    /**
     * Should generic services be generated in each language?  "Generic" services
     * are not specific to any particular RPC system.  They are generated by the
     * main code generators in each language (without additional plugins).
     * Generic services were the only kind of service generation supported by
     * early versions of google.protobuf.
     *
     * Generic services are now considered deprecated in favor of using plugins
     * that generate code specific to your particular RPC system.  Therefore,
     * these default to false.  Old code which depends on generic services should
     * explicitly set them to true.
     */
    ccGenericServices: boolean;
    javaGenericServices: boolean;
    pyGenericServices: boolean;
    phpGenericServices: boolean;
    /**
     * Is this file deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for everything in the file, or it will be completely ignored; in the very
     * least, this is a formalization for deprecating files.
     */
    deprecated: boolean;
    /**
     * Enables the use of arenas for the proto messages in this file. This applies
     * only to generated classes for C++.
     */
    ccEnableArenas: boolean;
    /**
     * Sets the objective c class prefix which is prepended to all objective c
     * generated classes from this .proto. There is no default.
     */
    objcClassPrefix: string;
    /** Namespace for generated classes; defaults to the package. */
    csharpNamespace: string;
    /**
     * By default Swift generators will take the proto package and CamelCase it
     * replacing '.' with underscore and use that to prefix the types/symbols
     * defined. When this options is provided, they will use this value instead
     * to prefix the types/symbols defined.
     */
    swiftPrefix: string;
    /**
     * Sets the php class prefix which is prepended to all php generated classes
     * from this .proto. Default is empty.
     */
    phpClassPrefix: string;
    /**
     * Use this option to change the namespace of php generated classes. Default
     * is empty. When this option is empty, the package name will be used for
     * determining the namespace.
     */
    phpNamespace: string;
    /**
     * Use this option to change the namespace of php generated metadata classes.
     * Default is empty. When this option is empty, the proto file name will be
     * used for determining the namespace.
     */
    phpMetadataNamespace: string;
    /**
     * Use this option to change the package of ruby generated classes. Default
     * is empty. When this option is not set, the package name will be used for
     * determining the ruby package.
     */
    rubyPackage: string;
    /**
     * The parser stores options it doesn't recognize here.
     * See the documentation for the "Options" section above.
     */
    uninterpretedOption: UninterpretedOption[];
}
export interface MessageOptions {
    /**
     * Set true to use the old proto1 MessageSet wire format for extensions.
     * This is provided for backwards-compatibility with the MessageSet wire
     * format.  You should not use this for any other reason:  It's less
     * efficient, has fewer features, and is more complicated.
     *
     * The message must be defined exactly as follows:
     *   message Foo {
     *     option message_set_wire_format = true;
     *     extensions 4 to max;
     *   }
     * Note that the message cannot have any defined fields; MessageSets only
     * have extensions.
     *
     * All extensions of your type must be singular messages; e.g. they cannot
     * be int32s, enums, or repeated messages.
     *
     * Because this is an option, the above two restrictions are not enforced by
     * the protocol compiler.
     */
    messageSetWireFormat: boolean;
    /**
     * Disables the generation of the standard "descriptor()" accessor, which can
     * conflict with a field of the same name.  This is meant to make migration
     * from proto1 easier; new code should avoid fields named "descriptor".
     */
    noStandardDescriptorAccessor: boolean;
    /**
     * Is this message deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the message, or it will be completely ignored; in the very least,
     * this is a formalization for deprecating messages.
     */
    deprecated: boolean;
    /**
     * Whether the message is an automatically generated map entry type for the
     * maps field.
     *
     * For maps fields:
     *     map<KeyType, ValueType> map_field = 1;
     * The parsed descriptor looks like:
     *     message MapFieldEntry {
     *         option map_entry = true;
     *         optional KeyType key = 1;
     *         optional ValueType value = 2;
     *     }
     *     repeated MapFieldEntry map_field = 1;
     *
     * Implementations may choose not to generate the map_entry=true message, but
     * use a native map in the target language to hold the keys and values.
     * The reflection APIs in such implementations still need to work as
     * if the field is a repeated message field.
     *
     * NOTE: Do not set the option in .proto files. Always use the maps syntax
     * instead. The option should only be implicitly set by the proto compiler
     * parser.
     */
    mapEntry: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface FieldOptions {
    /**
     * The ctype option instructs the C++ code generator to use a different
     * representation of the field than it normally would.  See the specific
     * options below.  This option is not yet implemented in the open source
     * release -- sorry, we'll try to include it in a future version!
     */
    ctype: FieldOptions_CType;
    /**
     * The packed option can be enabled for repeated primitive fields to enable
     * a more efficient representation on the wire. Rather than repeatedly
     * writing the tag and type for each element, the entire array is encoded as
     * a single length-delimited blob. In proto3, only explicit setting it to
     * false will avoid using packed encoding.
     */
    packed: boolean;
    /**
     * The jstype option determines the JavaScript type used for values of the
     * field.  The option is permitted only for 64 bit integral and fixed types
     * (int64, uint64, sint64, fixed64, sfixed64).  A field with jstype JS_STRING
     * is represented as JavaScript string, which avoids loss of precision that
     * can happen when a large value is converted to a floating point JavaScript.
     * Specifying JS_NUMBER for the jstype causes the generated JavaScript code to
     * use the JavaScript "number" type.  The behavior of the default option
     * JS_NORMAL is implementation dependent.
     *
     * This option is an enum to permit additional types to be added, e.g.
     * goog.math.Integer.
     */
    jstype: FieldOptions_JSType;
    /**
     * Should this field be parsed lazily?  Lazy applies only to message-type
     * fields.  It means that when the outer message is initially parsed, the
     * inner message's contents will not be parsed but instead stored in encoded
     * form.  The inner message will actually be parsed when it is first accessed.
     *
     * This is only a hint.  Implementations are free to choose whether to use
     * eager or lazy parsing regardless of the value of this option.  However,
     * setting this option true suggests that the protocol author believes that
     * using lazy parsing on this field is worth the additional bookkeeping
     * overhead typically needed to implement it.
     *
     * This option does not affect the public interface of any generated code;
     * all method signatures remain the same.  Furthermore, thread-safety of the
     * interface is not affected by this option; const methods remain safe to
     * call from multiple threads concurrently, while non-const methods continue
     * to require exclusive access.
     *
     *
     * Note that implementations may choose not to check required fields within
     * a lazy sub-message.  That is, calling IsInitialized() on the outer message
     * may return true even if the inner message has missing required fields.
     * This is necessary because otherwise the inner message would have to be
     * parsed in order to perform the check, defeating the purpose of lazy
     * parsing.  An implementation which chooses not to check required fields
     * must be consistent about it.  That is, for any particular sub-message, the
     * implementation must either *always* check its required fields, or *never*
     * check its required fields, regardless of whether or not the message has
     * been parsed.
     */
    lazy: boolean;
    /**
     * Is this field deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for accessors, or it will be completely ignored; in the very least, this
     * is a formalization for deprecating fields.
     */
    deprecated: boolean;
    /** For Google-internal migration only. Do not use. */
    weak: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface OneofOptions {
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface EnumOptions {
    /**
     * Set this option to true to allow mapping different tag names to the same
     * value.
     */
    allowAlias: boolean;
    /**
     * Is this enum deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the enum, or it will be completely ignored; in the very least, this
     * is a formalization for deprecating enums.
     */
    deprecated: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface EnumValueOptions {
    /**
     * Is this enum value deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the enum value, or it will be completely ignored; in the very least,
     * this is a formalization for deprecating enum values.
     */
    deprecated: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface ServiceOptions {
    /**
     * Is this service deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the service, or it will be completely ignored; in the very least,
     * this is a formalization for deprecating services.
     */
    deprecated: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface MethodOptions {
    /**
     * Is this method deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the method, or it will be completely ignored; in the very least,
     * this is a formalization for deprecating methods.
     */
    deprecated: boolean;
    idempotencyLevel: MethodOptions_IdempotencyLevel;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
/**
 * A message representing a option the parser does not recognize. This only
 * appears in options protos created by the compiler::Parser class.
 * DescriptorPool resolves these when building Descriptor objects. Therefore,
 * options protos in descriptor objects (e.g. returned by Descriptor::options(),
 * or produced by Descriptor::CopyTo()) will never have UninterpretedOptions
 * in them.
 */
export interface UninterpretedOption {
    name: UninterpretedOption_NamePart[];
    /**
     * The value of the uninterpreted option, in whatever type the tokenizer
     * identified it as during parsing. Exactly one of these should be set.
     */
    identifierValue: string;
    positiveIntValue: bigint;
    negativeIntValue: bigint;
    doubleValue: number;
    stringValue: Uint8Array;
    aggregateValue: string;
}
/**
 * The name of the uninterpreted option.  Each string represents a segment in
 * a dot-separated name.  is_extension is true iff a segment represents an
 * extension (denoted with parentheses in options specs in .proto files).
 * E.g.,{ ["foo", false], ["bar.baz", true], ["qux", false] } represents
 * "foo.(bar.baz).qux".
 */
export interface UninterpretedOption_NamePart {
    namePart: string;
    isExtension: boolean;
}
/**
 * Encapsulates information about the original source file from which a
 * FileDescriptorProto was generated.
 */
export interface SourceCodeInfo {
    /**
     * A Location identifies a piece of source code in a .proto file which
     * corresponds to a particular definition.  This information is intended
     * to be useful to IDEs, code indexers, documentation generators, and similar
     * tools.
     *
     * For example, say we have a file like:
     *   message Foo {
     *     optional string foo = 1;
     *   }
     * Let's look at just the field definition:
     *   optional string foo = 1;
     *   ^       ^^     ^^  ^  ^^^
     *   a       bc     de  f  ghi
     * We have the following locations:
     *   span   path               represents
     *   [a,i)  [ 4, 0, 2, 0 ]     The whole field definition.
     *   [a,b)  [ 4, 0, 2, 0, 4 ]  The label (optional).
     *   [c,d)  [ 4, 0, 2, 0, 5 ]  The type (string).
     *   [e,f)  [ 4, 0, 2, 0, 1 ]  The name (foo).
     *   [g,h)  [ 4, 0, 2, 0, 3 ]  The number (1).
     *
     * Notes:
     * - A location may refer to a repeated field itself (i.e. not to any
     *   particular index within it).  This is used whenever a set of elements are
     *   logically enclosed in a single code segment.  For example, an entire
     *   extend block (possibly containing multiple extension definitions) will
     *   have an outer location whose path refers to the "extensions" repeated
     *   field without an index.
     * - Multiple locations may have the same path.  This happens when a single
     *   logical declaration is spread out across multiple places.  The most
     *   obvious example is the "extend" block again -- there may be multiple
     *   extend blocks in the same scope, each of which will have the same path.
     * - A location's span is not always a subset of its parent's span.  For
     *   example, the "extendee" of an extension declaration appears at the
     *   beginning of the "extend" block and is shared by all extensions within
     *   the block.
     * - Just because a location's span is a subset of some other location's span
     *   does not mean that it is a descendant.  For example, a "group" defines
     *   both a type and a field in a single declaration.  Thus, the locations
     *   corresponding to the type and field and their components will overlap.
     * - Code which tries to interpret locations should probably be designed to
     *   ignore those that it doesn't understand, as more types of locations could
     *   be recorded in the future.
     */
    location: SourceCodeInfo_Location[];
}
export interface SourceCodeInfo_Location {
    /**
     * Identifies which part of the FileDescriptorProto was defined at this
     * location.
     *
     * Each element is a field number or an index.  They form a path from
     * the root FileDescriptorProto to the place where the definition.  For
     * example, this path:
     *   [ 4, 3, 2, 7, 1 ]
     * refers to:
     *   file.message_type(3)  // 4, 3
     *       .field(7)         // 2, 7
     *       .name()           // 1
     * This is because FileDescriptorProto.message_type has field number 4:
     *   repeated DescriptorProto message_type = 4;
     * and DescriptorProto.field has field number 2:
     *   repeated FieldDescriptorProto field = 2;
     * and FieldDescriptorProto.name has field number 1:
     *   optional string name = 1;
     *
     * Thus, the above path gives the location of a field name.  If we removed
     * the last element:
     *   [ 4, 3, 2, 7 ]
     * this path refers to the whole field declaration (from the beginning
     * of the label to the terminating semicolon).
     */
    path: number[];
    /**
     * Always has exactly three or four elements: start line, start column,
     * end line (optional, otherwise assumed same as start line), end column.
     * These are packed into a single field for efficiency.  Note that line
     * and column numbers are zero-based -- typically you will want to add
     * 1 to each before displaying to a user.
     */
    span: number[];
    /**
     * If this SourceCodeInfo represents a complete declaration, these are any
     * comments appearing before and after the declaration which appear to be
     * attached to the declaration.
     *
     * A series of line comments appearing on consecutive lines, with no other
     * tokens appearing on those lines, will be treated as a single comment.
     *
     * leading_detached_comments will keep paragraphs of comments that appear
     * before (but not connected to) the current element. Each paragraph,
     * separated by empty lines, will be one comment element in the repeated
     * field.
     *
     * Only the comment content is provided; comment markers (e.g. //) are
     * stripped out.  For block comments, leading whitespace and an asterisk
     * will be stripped from the beginning of each line other than the first.
     * Newlines are included in the output.
     *
     * Examples:
     *
     *   optional int32 foo = 1;  // Comment attached to foo.
     *   // Comment attached to bar.
     *   optional int32 bar = 2;
     *
     *   optional string baz = 3;
     *   // Comment attached to baz.
     *   // Another line attached to baz.
     *
     *   // Comment attached to qux.
     *   //
     *   // Another line attached to qux.
     *   optional double qux = 4;
     *
     *   // Detached comment for corge. This is not leading or trailing comments
     *   // to qux or corge because there are blank lines separating it from
     *   // both.
     *
     *   // Detached comment for corge paragraph 2.
     *
     *   optional string corge = 5;
     *   /* Block comment attached
     *    * to corge.  Leading asterisks
     *    * will be removed. *\/
     *   /* Block comment attached to
     *    * grault. *\/
     *   optional int32 grault = 6;
     *
     *   // ignored detached comments.
     */
    leadingComments: string;
    trailingComments: string;
    leadingDetachedComments: string[];
}
/**
 * Describes the relationship between generated code and its original source
 * file. A GeneratedCodeInfo message is associated with only one generated
 * source file, but may contain references to different source .proto files.
 */
export interface GeneratedCodeInfo {
    /**
     * An Annotation connects some span of text in generated code to an element
     * of its generating .proto file.
     */
    annotation: GeneratedCodeInfo_Annotation[];
}
export interface GeneratedCodeInfo_Annotation {
    /**
     * Identifies the element in the original source .proto file. This field
     * is formatted the same as SourceCodeInfo.Location.path.
     */
    path: number[];
    /** Identifies the filesystem path to the original source .proto. */
    sourceFile: string;
    /**
     * Identifies the starting offset in bytes in the generated code
     * that relates to the identified object.
     */
    begin: number;
    /**
     * Identifies the ending offset in bytes in the generated code that
     * relates to the identified offset. The end offset should be one past
     * the last relevant byte (so the length of the text = end - begin).
     */
    end: number;
}
export declare const FileDescriptorSet: {
    typeUrl: string;
    encode(message: FileDescriptorSet, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): FileDescriptorSet;
    fromJSON(object: any): FileDescriptorSet;
    toJSON(message: FileDescriptorSet): unknown;
    fromPartial<I extends {
        file?: {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[] | undefined;
    } & {
        file?: ({
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[] & ({
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        } & {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["dependency"], keyof string[]>, never>) | undefined;
            publicDependency?: (number[] & number[] & Record<Exclude<keyof I["file"][number]["publicDependency"], keyof number[]>, never>) | undefined;
            weakDependency?: (number[] & number[] & Record<Exclude<keyof I["file"][number]["weakDependency"], keyof number[]>, never>) | undefined;
            messageType?: ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                field?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["field"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                extension?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["extension"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                nestedType?: ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    field?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    extension?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    nestedType?: ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        field?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        extension?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        nestedType?: ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            field?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            extension?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            nestedType?: ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                field?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                extension?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                nestedType?: ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    field?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    extension?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    nestedType?: ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        field?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        extension?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        nestedType?: ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            field?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            extension?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            nestedType?: ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                field?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                extension?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                nestedType?: ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>, never>) | undefined;
                                                enumType?: ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>, never>) | undefined;
                                                extensionRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                oneofDecl?: ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                options?: ({
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>, never>) | undefined;
                                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>, never>) | undefined;
                                            enumType?: ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                value?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                options?: ({
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>, never>) | undefined;
                                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>, never>) | undefined;
                                            extensionRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            oneofDecl?: ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            options?: ({
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>, never>) | undefined;
                                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>, never>) | undefined;
                                        enumType?: ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            value?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: ({
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            options?: ({
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>, never>) | undefined;
                                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>, never>) | undefined;
                                        extensionRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        oneofDecl?: ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        options?: ({
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>, never>) | undefined;
                                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>, never>) | undefined;
                                    enumType?: ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        value?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: ({
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        options?: ({
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>, never>) | undefined;
                                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>, never>) | undefined;
                                    extensionRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    oneofDecl?: ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    options?: ({
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>, never>) | undefined;
                                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>, never>) | undefined;
                                enumType?: ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    value?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: ({
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    options?: ({
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>, never>) | undefined;
                                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>, never>) | undefined;
                                extensionRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                oneofDecl?: ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                options?: ({
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>, never>) | undefined;
                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>, never>) | undefined;
                            enumType?: ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                value?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: ({
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                options?: ({
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>, never>) | undefined;
                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>, never>) | undefined;
                            extensionRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            oneofDecl?: ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            options?: ({
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>, never>) | undefined;
                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>, never>) | undefined;
                        enumType?: ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            value?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: ({
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            options?: ({
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>, never>) | undefined;
                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>, never>) | undefined;
                        extensionRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        oneofDecl?: ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        options?: ({
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>, never>) | undefined;
                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"], keyof {
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>, never>) | undefined;
                    enumType?: ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        value?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: ({
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        options?: ({
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>, never>) | undefined;
                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"], keyof {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>, never>) | undefined;
                    extensionRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    oneofDecl?: ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"], keyof {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    options?: ({
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>, never>) | undefined;
                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["nestedType"], keyof {
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>, never>) | undefined;
                enumType?: ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    value?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: ({
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    options?: ({
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>, never>) | undefined;
                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["enumType"], keyof {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>, never>) | undefined;
                extensionRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                oneofDecl?: ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"], keyof {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & Record<Exclude<keyof I["file"][number]["messageType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>, never>) | undefined;
                reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["messageType"][number]["reservedName"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["file"][number]["messageType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["messageType"], keyof {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>, never>) | undefined;
            enumType?: ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                value?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["enumType"][number]["value"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & Record<Exclude<keyof I["file"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["file"][number]["enumType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>, never>) | undefined;
                reservedName?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["file"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["enumType"], keyof {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>, never>) | undefined;
            service?: ({
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                method?: ({
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"], keyof MethodOptions>, never>) | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                } & Record<Exclude<keyof I["file"][number]["service"][number]["method"][number], keyof MethodDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["service"][number]["method"], keyof {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["service"][number]["options"], keyof ServiceOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["file"][number]["service"][number], keyof ServiceDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["service"], keyof {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            extension?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["file"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"][number]["extension"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            options?: ({
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["file"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["file"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["file"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["file"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["file"][number]["options"], keyof FileOptions>, never>) | undefined;
            sourceCodeInfo?: ({
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } & {
                location?: ({
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] & ({
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                } & {
                    path?: (number[] & number[] & Record<Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"][number]["path"], keyof number[]>, never>) | undefined;
                    span?: (number[] & number[] & Record<Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"][number]["span"], keyof number[]>, never>) | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: (string[] & string[] & Record<Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"][number]["leadingDetachedComments"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"][number], keyof SourceCodeInfo_Location>, never>)[] & Record<Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"], keyof {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["file"][number]["sourceCodeInfo"], "location">, never>) | undefined;
            syntax?: string | undefined;
        } & Record<Exclude<keyof I["file"][number], keyof FileDescriptorProto>, never>)[] & Record<Exclude<keyof I["file"], keyof {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, "file">, never>>(object: I): FileDescriptorSet;
};
export declare const FileDescriptorProto: {
    typeUrl: string;
    encode(message: FileDescriptorProto, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): FileDescriptorProto;
    fromJSON(object: any): FileDescriptorProto;
    toJSON(message: FileDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        package?: string | undefined;
        dependency?: string[] | undefined;
        publicDependency?: number[] | undefined;
        weakDependency?: number[] | undefined;
        messageType?: {
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] | undefined;
        enumType?: {
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] | undefined;
        service?: {
            name?: string | undefined;
            method?: {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        extension?: {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        options?: {
            javaPackage?: string | undefined;
            javaOuterClassname?: string | undefined;
            javaMultipleFiles?: boolean | undefined;
            javaGenerateEqualsAndHash?: boolean | undefined;
            javaStringCheckUtf8?: boolean | undefined;
            optimizeFor?: FileOptions_OptimizeMode | undefined;
            goPackage?: string | undefined;
            ccGenericServices?: boolean | undefined;
            javaGenericServices?: boolean | undefined;
            pyGenericServices?: boolean | undefined;
            phpGenericServices?: boolean | undefined;
            deprecated?: boolean | undefined;
            ccEnableArenas?: boolean | undefined;
            objcClassPrefix?: string | undefined;
            csharpNamespace?: string | undefined;
            swiftPrefix?: string | undefined;
            phpClassPrefix?: string | undefined;
            phpNamespace?: string | undefined;
            phpMetadataNamespace?: string | undefined;
            rubyPackage?: string | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        sourceCodeInfo?: {
            location?: {
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            }[] | undefined;
        } | undefined;
        syntax?: string | undefined;
    } & {
        name?: string | undefined;
        package?: string | undefined;
        dependency?: (string[] & string[] & Record<Exclude<keyof I["dependency"], keyof string[]>, never>) | undefined;
        publicDependency?: (number[] & number[] & Record<Exclude<keyof I["publicDependency"], keyof number[]>, never>) | undefined;
        weakDependency?: (number[] & number[] & Record<Exclude<keyof I["weakDependency"], keyof number[]>, never>) | undefined;
        messageType?: ({
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] & ({
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        } & {
            name?: string | undefined;
            field?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["messageType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["field"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            extension?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["messageType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["extension"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            nestedType?: ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                field?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["field"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                extension?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                nestedType?: ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    field?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    extension?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    nestedType?: ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        field?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        extension?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        nestedType?: ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            field?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            extension?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            nestedType?: ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                field?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                extension?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                nestedType?: ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    field?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    extension?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    nestedType?: ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        field?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        extension?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        nestedType?: ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            field?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            extension?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            nestedType?: ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                field?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                extension?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                nestedType?: ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>, never>) | undefined;
                                                enumType?: ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>, never>) | undefined;
                                                extensionRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                oneofDecl?: ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                options?: ({
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>, never>) | undefined;
                                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>, never>) | undefined;
                                            enumType?: ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                value?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                options?: ({
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>, never>) | undefined;
                                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>, never>) | undefined;
                                            extensionRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            oneofDecl?: ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            options?: ({
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>, never>) | undefined;
                                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>, never>) | undefined;
                                        enumType?: ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            value?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: ({
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            options?: ({
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>, never>) | undefined;
                                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>, never>) | undefined;
                                        extensionRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        oneofDecl?: ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        options?: ({
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>, never>) | undefined;
                                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>, never>) | undefined;
                                    enumType?: ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        value?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: ({
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        options?: ({
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>, never>) | undefined;
                                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>, never>) | undefined;
                                    extensionRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    oneofDecl?: ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    options?: ({
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>, never>) | undefined;
                                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>, never>) | undefined;
                                enumType?: ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    value?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: ({
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    options?: ({
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>, never>) | undefined;
                                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>, never>) | undefined;
                                extensionRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                oneofDecl?: ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                options?: ({
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>, never>) | undefined;
                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>, never>) | undefined;
                            enumType?: ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                value?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: ({
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                options?: ({
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>, never>) | undefined;
                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>, never>) | undefined;
                            extensionRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            oneofDecl?: ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            options?: ({
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>, never>) | undefined;
                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>, never>) | undefined;
                        enumType?: ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            value?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: ({
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            options?: ({
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>, never>) | undefined;
                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>, never>) | undefined;
                        extensionRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        oneofDecl?: ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        options?: ({
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>, never>) | undefined;
                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>, never>) | undefined;
                    enumType?: ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        value?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: ({
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        options?: ({
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>, never>) | undefined;
                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>, never>) | undefined;
                    extensionRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    oneofDecl?: ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    options?: ({
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>, never>) | undefined;
                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"], keyof {
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>, never>) | undefined;
                enumType?: ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    value?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: ({
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    options?: ({
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>, never>) | undefined;
                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"], keyof {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>, never>) | undefined;
                extensionRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                oneofDecl?: ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"], keyof {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>, never>) | undefined;
                reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["messageType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["nestedType"], keyof {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>, never>) | undefined;
            enumType?: ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                value?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["value"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>, never>) | undefined;
                reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["messageType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["enumType"], keyof {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>, never>) | undefined;
            extensionRange?: ({
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
                options?: ({
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
            } & Record<Exclude<keyof I["messageType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["extensionRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            oneofDecl?: ({
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                options?: ({
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
            } & Record<Exclude<keyof I["messageType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"][number]["oneofDecl"], keyof {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            options?: ({
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["messageType"][number]["options"], keyof MessageOptions>, never>) | undefined;
            reservedRange?: ({
                start?: number | undefined;
                end?: number | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
            } & Record<Exclude<keyof I["messageType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["messageType"][number]["reservedRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
            }[]>, never>) | undefined;
            reservedName?: (string[] & string[] & Record<Exclude<keyof I["messageType"][number]["reservedName"], keyof string[]>, never>) | undefined;
        } & Record<Exclude<keyof I["messageType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["messageType"], keyof {
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[]>, never>) | undefined;
        enumType?: ({
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] & ({
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        } & {
            name?: string | undefined;
            value?: ({
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["enumType"][number]["value"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            options?: ({
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
            reservedRange?: ({
                start?: number | undefined;
                end?: number | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
            } & Record<Exclude<keyof I["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["enumType"][number]["reservedRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
            }[]>, never>) | undefined;
            reservedName?: (string[] & string[] & Record<Exclude<keyof I["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
        } & Record<Exclude<keyof I["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["enumType"], keyof {
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[]>, never>) | undefined;
        service?: ({
            name?: string | undefined;
            method?: {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            method?: {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            method?: ({
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] & ({
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            } & {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["service"][number]["method"][number]["options"], keyof MethodOptions>, never>) | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            } & Record<Exclude<keyof I["service"][number]["method"][number], keyof MethodDescriptorProto>, never>)[] & Record<Exclude<keyof I["service"][number]["method"], keyof {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[]>, never>) | undefined;
            options?: ({
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                deprecated?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["service"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["service"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["service"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["service"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["service"][number]["options"], keyof ServiceOptions>, never>) | undefined;
        } & Record<Exclude<keyof I["service"][number], keyof ServiceDescriptorProto>, never>)[] & Record<Exclude<keyof I["service"], keyof {
            name?: string | undefined;
            method?: {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>, never>) | undefined;
        extension?: ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: ({
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
        } & Record<Exclude<keyof I["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["extension"], keyof {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>, never>) | undefined;
        options?: ({
            javaPackage?: string | undefined;
            javaOuterClassname?: string | undefined;
            javaMultipleFiles?: boolean | undefined;
            javaGenerateEqualsAndHash?: boolean | undefined;
            javaStringCheckUtf8?: boolean | undefined;
            optimizeFor?: FileOptions_OptimizeMode | undefined;
            goPackage?: string | undefined;
            ccGenericServices?: boolean | undefined;
            javaGenericServices?: boolean | undefined;
            pyGenericServices?: boolean | undefined;
            phpGenericServices?: boolean | undefined;
            deprecated?: boolean | undefined;
            ccEnableArenas?: boolean | undefined;
            objcClassPrefix?: string | undefined;
            csharpNamespace?: string | undefined;
            swiftPrefix?: string | undefined;
            phpClassPrefix?: string | undefined;
            phpNamespace?: string | undefined;
            phpMetadataNamespace?: string | undefined;
            rubyPackage?: string | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            javaPackage?: string | undefined;
            javaOuterClassname?: string | undefined;
            javaMultipleFiles?: boolean | undefined;
            javaGenerateEqualsAndHash?: boolean | undefined;
            javaStringCheckUtf8?: boolean | undefined;
            optimizeFor?: FileOptions_OptimizeMode | undefined;
            goPackage?: string | undefined;
            ccGenericServices?: boolean | undefined;
            javaGenericServices?: boolean | undefined;
            pyGenericServices?: boolean | undefined;
            phpGenericServices?: boolean | undefined;
            deprecated?: boolean | undefined;
            ccEnableArenas?: boolean | undefined;
            objcClassPrefix?: string | undefined;
            csharpNamespace?: string | undefined;
            swiftPrefix?: string | undefined;
            phpClassPrefix?: string | undefined;
            phpNamespace?: string | undefined;
            phpMetadataNamespace?: string | undefined;
            rubyPackage?: string | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], keyof FileOptions>, never>) | undefined;
        sourceCodeInfo?: ({
            location?: {
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            }[] | undefined;
        } & {
            location?: ({
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            }[] & ({
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            } & {
                path?: (number[] & number[] & Record<Exclude<keyof I["sourceCodeInfo"]["location"][number]["path"], keyof number[]>, never>) | undefined;
                span?: (number[] & number[] & Record<Exclude<keyof I["sourceCodeInfo"]["location"][number]["span"], keyof number[]>, never>) | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: (string[] & string[] & Record<Exclude<keyof I["sourceCodeInfo"]["location"][number]["leadingDetachedComments"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["sourceCodeInfo"]["location"][number], keyof SourceCodeInfo_Location>, never>)[] & Record<Exclude<keyof I["sourceCodeInfo"]["location"], keyof {
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["sourceCodeInfo"], "location">, never>) | undefined;
        syntax?: string | undefined;
    } & Record<Exclude<keyof I, keyof FileDescriptorProto>, never>>(object: I): FileDescriptorProto;
};
export declare const DescriptorProto: {
    typeUrl: string;
    encode(message: DescriptorProto, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DescriptorProto;
    fromJSON(object: any): DescriptorProto;
    toJSON(message: DescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        field?: {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        extension?: {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        nestedType?: any[] | undefined;
        enumType?: {
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] | undefined;
        extensionRange?: {
            start?: number | undefined;
            end?: number | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        oneofDecl?: {
            name?: string | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        options?: {
            messageSetWireFormat?: boolean | undefined;
            noStandardDescriptorAccessor?: boolean | undefined;
            deprecated?: boolean | undefined;
            mapEntry?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        reservedRange?: {
            start?: number | undefined;
            end?: number | undefined;
        }[] | undefined;
        reservedName?: string[] | undefined;
    } & {
        name?: string | undefined;
        field?: ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: ({
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["field"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
        } & Record<Exclude<keyof I["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["field"], keyof {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>, never>) | undefined;
        extension?: ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: ({
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
        } & Record<Exclude<keyof I["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["extension"], keyof {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>, never>) | undefined;
        nestedType?: ({
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] & ({
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        } & {
            name?: string | undefined;
            field?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["field"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            extension?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["extension"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            nestedType?: ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                field?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                extension?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                nestedType?: ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    field?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    extension?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    nestedType?: ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        field?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        extension?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        nestedType?: ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            field?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            extension?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            nestedType?: ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                field?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                extension?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                nestedType?: ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    field?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    extension?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    nestedType?: ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        field?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        extension?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        nestedType?: ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            field?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            extension?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            nestedType?: ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                field?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                extension?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                nestedType?: ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: bigint | undefined;
                                                                    negativeIntValue?: bigint | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>, never>) | undefined;
                                                enumType?: ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>, never>) | undefined;
                                                extensionRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                oneofDecl?: ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                options?: ({
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>, never>) | undefined;
                                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: bigint | undefined;
                                                                negativeIntValue?: bigint | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>, never>) | undefined;
                                            enumType?: ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                value?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>, never>) | undefined;
                                                options?: ({
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>, never>) | undefined;
                                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>, never>) | undefined;
                                            extensionRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            oneofDecl?: ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            options?: ({
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>, never>) | undefined;
                                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: bigint | undefined;
                                                            negativeIntValue?: bigint | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>, never>) | undefined;
                                        enumType?: ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            value?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: ({
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>, never>) | undefined;
                                            options?: ({
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>, never>) | undefined;
                                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>, never>) | undefined;
                                        extensionRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        oneofDecl?: ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        options?: ({
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>, never>) | undefined;
                                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: bigint | undefined;
                                                        negativeIntValue?: bigint | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>, never>) | undefined;
                                    enumType?: ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        value?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: ({
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>, never>) | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>, never>) | undefined;
                                        options?: ({
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>, never>) | undefined;
                                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>, never>) | undefined;
                                    extensionRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    oneofDecl?: ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    options?: ({
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>, never>) | undefined;
                                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: bigint | undefined;
                                                    negativeIntValue?: bigint | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>, never>) | undefined;
                                enumType?: ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    value?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: ({
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>, never>) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>, never>) | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>, never>) | undefined;
                                    options?: ({
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>, never>) | undefined;
                                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>, never>) | undefined;
                                extensionRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                oneofDecl?: ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                options?: ({
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>, never>) | undefined;
                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: bigint | undefined;
                                                negativeIntValue?: bigint | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>, never>) | undefined;
                            enumType?: ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                value?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: ({
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>, never>) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>, never>) | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>, never>) | undefined;
                                options?: ({
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>, never>) | undefined;
                                reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>, never>) | undefined;
                            extensionRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            oneofDecl?: ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            options?: ({
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>, never>) | undefined;
                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: bigint | undefined;
                                            negativeIntValue?: bigint | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>, never>) | undefined;
                        enumType?: ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            value?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: ({
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>, never>) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>, never>) | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>, never>) | undefined;
                            options?: ({
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>, never>) | undefined;
                            reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>, never>) | undefined;
                        extensionRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        oneofDecl?: ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        options?: ({
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>, never>) | undefined;
                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: bigint | undefined;
                                        negativeIntValue?: bigint | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>, never>) | undefined;
                    enumType?: ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        value?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: ({
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>, never>) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>, never>) | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>, never>) | undefined;
                        options?: ({
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>, never>) | undefined;
                        reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>, never>) | undefined;
                    extensionRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    oneofDecl?: ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    options?: ({
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>, never>) | undefined;
                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: bigint | undefined;
                                    negativeIntValue?: bigint | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>, never>) | undefined;
                enumType?: ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    value?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: ({
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>, never>) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>, never>) | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>, never>) | undefined;
                    options?: ({
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>, never>) | undefined;
                    reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>, never>) | undefined;
                extensionRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                oneofDecl?: ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>, never>) | undefined;
                reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["nestedType"][number]["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["nestedType"], keyof {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: bigint | undefined;
                                negativeIntValue?: bigint | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>, never>) | undefined;
            enumType?: ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                value?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>, never>) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>, never>) | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["value"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>, never>) | undefined;
                options?: ({
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>, never>) | undefined;
                reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
            } & Record<Exclude<keyof I["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["enumType"], keyof {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>, never>) | undefined;
            extensionRange?: ({
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
                options?: ({
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
            } & Record<Exclude<keyof I["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["extensionRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            oneofDecl?: ({
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                options?: ({
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
            } & Record<Exclude<keyof I["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["oneofDecl"], keyof {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            options?: ({
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["nestedType"][number]["options"], keyof MessageOptions>, never>) | undefined;
            reservedRange?: ({
                start?: number | undefined;
                end?: number | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
            } & Record<Exclude<keyof I["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["nestedType"][number]["reservedRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
            }[]>, never>) | undefined;
            reservedName?: (string[] & string[] & Record<Exclude<keyof I["nestedType"][number]["reservedName"], keyof string[]>, never>) | undefined;
        } & Record<Exclude<keyof I["nestedType"][number], keyof DescriptorProto>, never>)[] & Record<Exclude<keyof I["nestedType"], keyof {
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: bigint | undefined;
                            negativeIntValue?: bigint | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[]>, never>) | undefined;
        enumType?: ({
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] & ({
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        } & {
            name?: string | undefined;
            value?: ({
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>, never>) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>, never>) | undefined;
                } & Record<Exclude<keyof I["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
            } & Record<Exclude<keyof I["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["enumType"][number]["value"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>, never>) | undefined;
            options?: ({
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["enumType"][number]["options"], keyof EnumOptions>, never>) | undefined;
            reservedRange?: ({
                start?: number | undefined;
                end?: number | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
            } & Record<Exclude<keyof I["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["enumType"][number]["reservedRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
            }[]>, never>) | undefined;
            reservedName?: (string[] & string[] & Record<Exclude<keyof I["enumType"][number]["reservedName"], keyof string[]>, never>) | undefined;
        } & Record<Exclude<keyof I["enumType"][number], keyof EnumDescriptorProto>, never>)[] & Record<Exclude<keyof I["enumType"], keyof {
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: bigint | undefined;
                        negativeIntValue?: bigint | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[]>, never>) | undefined;
        extensionRange?: ({
            start?: number | undefined;
            end?: number | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            start?: number | undefined;
            end?: number | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            start?: number | undefined;
            end?: number | undefined;
            options?: ({
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["extensionRange"][number]["options"], "uninterpretedOption">, never>) | undefined;
        } & Record<Exclude<keyof I["extensionRange"][number], keyof DescriptorProto_ExtensionRange>, never>)[] & Record<Exclude<keyof I["extensionRange"], keyof {
            start?: number | undefined;
            end?: number | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>, never>) | undefined;
        oneofDecl?: ({
            name?: string | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            options?: ({
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["oneofDecl"][number]["options"], "uninterpretedOption">, never>) | undefined;
        } & Record<Exclude<keyof I["oneofDecl"][number], keyof OneofDescriptorProto>, never>)[] & Record<Exclude<keyof I["oneofDecl"], keyof {
            name?: string | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>, never>) | undefined;
        options?: ({
            messageSetWireFormat?: boolean | undefined;
            noStandardDescriptorAccessor?: boolean | undefined;
            deprecated?: boolean | undefined;
            mapEntry?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            messageSetWireFormat?: boolean | undefined;
            noStandardDescriptorAccessor?: boolean | undefined;
            deprecated?: boolean | undefined;
            mapEntry?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], keyof MessageOptions>, never>) | undefined;
        reservedRange?: ({
            start?: number | undefined;
            end?: number | undefined;
        }[] & ({
            start?: number | undefined;
            end?: number | undefined;
        } & {
            start?: number | undefined;
            end?: number | undefined;
        } & Record<Exclude<keyof I["reservedRange"][number], keyof DescriptorProto_ReservedRange>, never>)[] & Record<Exclude<keyof I["reservedRange"], keyof {
            start?: number | undefined;
            end?: number | undefined;
        }[]>, never>) | undefined;
        reservedName?: (string[] & string[] & Record<Exclude<keyof I["reservedName"], keyof string[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof DescriptorProto>, never>>(object: I): DescriptorProto;
};
export declare const DescriptorProto_ExtensionRange: {
    typeUrl: string;
    encode(message: DescriptorProto_ExtensionRange, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DescriptorProto_ExtensionRange;
    fromJSON(object: any): DescriptorProto_ExtensionRange;
    toJSON(message: DescriptorProto_ExtensionRange): unknown;
    fromPartial<I extends {
        start?: number | undefined;
        end?: number | undefined;
        options?: {
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        start?: number | undefined;
        end?: number | undefined;
        options?: ({
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], "uninterpretedOption">, never>) | undefined;
    } & Record<Exclude<keyof I, keyof DescriptorProto_ExtensionRange>, never>>(object: I): DescriptorProto_ExtensionRange;
};
export declare const DescriptorProto_ReservedRange: {
    typeUrl: string;
    encode(message: DescriptorProto_ReservedRange, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DescriptorProto_ReservedRange;
    fromJSON(object: any): DescriptorProto_ReservedRange;
    toJSON(message: DescriptorProto_ReservedRange): unknown;
    fromPartial<I extends {
        start?: number | undefined;
        end?: number | undefined;
    } & {
        start?: number | undefined;
        end?: number | undefined;
    } & Record<Exclude<keyof I, keyof DescriptorProto_ReservedRange>, never>>(object: I): DescriptorProto_ReservedRange;
};
export declare const ExtensionRangeOptions: {
    typeUrl: string;
    encode(message: ExtensionRangeOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ExtensionRangeOptions;
    fromJSON(object: any): ExtensionRangeOptions;
    toJSON(message: ExtensionRangeOptions): unknown;
    fromPartial<I extends {
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, "uninterpretedOption">, never>>(object: I): ExtensionRangeOptions;
};
export declare const FieldDescriptorProto: {
    typeUrl: string;
    encode(message: FieldDescriptorProto, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): FieldDescriptorProto;
    fromJSON(object: any): FieldDescriptorProto;
    toJSON(message: FieldDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        number?: number | undefined;
        label?: FieldDescriptorProto_Label | undefined;
        type?: FieldDescriptorProto_Type | undefined;
        typeName?: string | undefined;
        extendee?: string | undefined;
        defaultValue?: string | undefined;
        oneofIndex?: number | undefined;
        jsonName?: string | undefined;
        options?: {
            ctype?: FieldOptions_CType | undefined;
            packed?: boolean | undefined;
            jstype?: FieldOptions_JSType | undefined;
            lazy?: boolean | undefined;
            deprecated?: boolean | undefined;
            weak?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        name?: string | undefined;
        number?: number | undefined;
        label?: FieldDescriptorProto_Label | undefined;
        type?: FieldDescriptorProto_Type | undefined;
        typeName?: string | undefined;
        extendee?: string | undefined;
        defaultValue?: string | undefined;
        oneofIndex?: number | undefined;
        jsonName?: string | undefined;
        options?: ({
            ctype?: FieldOptions_CType | undefined;
            packed?: boolean | undefined;
            jstype?: FieldOptions_JSType | undefined;
            lazy?: boolean | undefined;
            deprecated?: boolean | undefined;
            weak?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            ctype?: FieldOptions_CType | undefined;
            packed?: boolean | undefined;
            jstype?: FieldOptions_JSType | undefined;
            lazy?: boolean | undefined;
            deprecated?: boolean | undefined;
            weak?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], keyof FieldOptions>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof FieldDescriptorProto>, never>>(object: I): FieldDescriptorProto;
};
export declare const OneofDescriptorProto: {
    typeUrl: string;
    encode(message: OneofDescriptorProto, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): OneofDescriptorProto;
    fromJSON(object: any): OneofDescriptorProto;
    toJSON(message: OneofDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        options?: {
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        name?: string | undefined;
        options?: ({
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], "uninterpretedOption">, never>) | undefined;
    } & Record<Exclude<keyof I, keyof OneofDescriptorProto>, never>>(object: I): OneofDescriptorProto;
};
export declare const EnumDescriptorProto: {
    typeUrl: string;
    encode(message: EnumDescriptorProto, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): EnumDescriptorProto;
    fromJSON(object: any): EnumDescriptorProto;
    toJSON(message: EnumDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        value?: {
            name?: string | undefined;
            number?: number | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        options?: {
            allowAlias?: boolean | undefined;
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        reservedRange?: {
            start?: number | undefined;
            end?: number | undefined;
        }[] | undefined;
        reservedName?: string[] | undefined;
    } & {
        name?: string | undefined;
        value?: ({
            name?: string | undefined;
            number?: number | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            number?: number | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            number?: number | undefined;
            options?: ({
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                deprecated?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["value"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["value"][number]["options"], keyof EnumValueOptions>, never>) | undefined;
        } & Record<Exclude<keyof I["value"][number], keyof EnumValueDescriptorProto>, never>)[] & Record<Exclude<keyof I["value"], keyof {
            name?: string | undefined;
            number?: number | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>, never>) | undefined;
        options?: ({
            allowAlias?: boolean | undefined;
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            allowAlias?: boolean | undefined;
            deprecated?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], keyof EnumOptions>, never>) | undefined;
        reservedRange?: ({
            start?: number | undefined;
            end?: number | undefined;
        }[] & ({
            start?: number | undefined;
            end?: number | undefined;
        } & {
            start?: number | undefined;
            end?: number | undefined;
        } & Record<Exclude<keyof I["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>, never>)[] & Record<Exclude<keyof I["reservedRange"], keyof {
            start?: number | undefined;
            end?: number | undefined;
        }[]>, never>) | undefined;
        reservedName?: (string[] & string[] & Record<Exclude<keyof I["reservedName"], keyof string[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof EnumDescriptorProto>, never>>(object: I): EnumDescriptorProto;
};
export declare const EnumDescriptorProto_EnumReservedRange: {
    typeUrl: string;
    encode(message: EnumDescriptorProto_EnumReservedRange, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): EnumDescriptorProto_EnumReservedRange;
    fromJSON(object: any): EnumDescriptorProto_EnumReservedRange;
    toJSON(message: EnumDescriptorProto_EnumReservedRange): unknown;
    fromPartial<I extends {
        start?: number | undefined;
        end?: number | undefined;
    } & {
        start?: number | undefined;
        end?: number | undefined;
    } & Record<Exclude<keyof I, keyof EnumDescriptorProto_EnumReservedRange>, never>>(object: I): EnumDescriptorProto_EnumReservedRange;
};
export declare const EnumValueDescriptorProto: {
    typeUrl: string;
    encode(message: EnumValueDescriptorProto, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): EnumValueDescriptorProto;
    fromJSON(object: any): EnumValueDescriptorProto;
    toJSON(message: EnumValueDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        number?: number | undefined;
        options?: {
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        name?: string | undefined;
        number?: number | undefined;
        options?: ({
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            deprecated?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], keyof EnumValueOptions>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof EnumValueDescriptorProto>, never>>(object: I): EnumValueDescriptorProto;
};
export declare const ServiceDescriptorProto: {
    typeUrl: string;
    encode(message: ServiceDescriptorProto, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ServiceDescriptorProto;
    fromJSON(object: any): ServiceDescriptorProto;
    toJSON(message: ServiceDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        method?: {
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        }[] | undefined;
        options?: {
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        name?: string | undefined;
        method?: ({
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        }[] & ({
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        } & {
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: ({
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & Record<Exclude<keyof I["method"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["method"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>, never>) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & Record<Exclude<keyof I["method"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["method"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>, never>) | undefined;
            } & Record<Exclude<keyof I["method"][number]["options"], keyof MethodOptions>, never>) | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        } & Record<Exclude<keyof I["method"][number], keyof MethodDescriptorProto>, never>)[] & Record<Exclude<keyof I["method"], keyof {
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: bigint | undefined;
                    negativeIntValue?: bigint | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        }[]>, never>) | undefined;
        options?: ({
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            deprecated?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], keyof ServiceOptions>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof ServiceDescriptorProto>, never>>(object: I): ServiceDescriptorProto;
};
export declare const MethodDescriptorProto: {
    typeUrl: string;
    encode(message: MethodDescriptorProto, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MethodDescriptorProto;
    fromJSON(object: any): MethodDescriptorProto;
    toJSON(message: MethodDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        inputType?: string | undefined;
        outputType?: string | undefined;
        options?: {
            deprecated?: boolean | undefined;
            idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        clientStreaming?: boolean | undefined;
        serverStreaming?: boolean | undefined;
    } & {
        name?: string | undefined;
        inputType?: string | undefined;
        outputType?: string | undefined;
        options?: ({
            deprecated?: boolean | undefined;
            idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            deprecated?: boolean | undefined;
            idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>, never>) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & Record<Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: bigint | undefined;
                negativeIntValue?: bigint | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>, never>) | undefined;
        } & Record<Exclude<keyof I["options"], keyof MethodOptions>, never>) | undefined;
        clientStreaming?: boolean | undefined;
        serverStreaming?: boolean | undefined;
    } & Record<Exclude<keyof I, keyof MethodDescriptorProto>, never>>(object: I): MethodDescriptorProto;
};
export declare const FileOptions: {
    typeUrl: string;
    encode(message: FileOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): FileOptions;
    fromJSON(object: any): FileOptions;
    toJSON(message: FileOptions): unknown;
    fromPartial<I extends {
        javaPackage?: string | undefined;
        javaOuterClassname?: string | undefined;
        javaMultipleFiles?: boolean | undefined;
        javaGenerateEqualsAndHash?: boolean | undefined;
        javaStringCheckUtf8?: boolean | undefined;
        optimizeFor?: FileOptions_OptimizeMode | undefined;
        goPackage?: string | undefined;
        ccGenericServices?: boolean | undefined;
        javaGenericServices?: boolean | undefined;
        pyGenericServices?: boolean | undefined;
        phpGenericServices?: boolean | undefined;
        deprecated?: boolean | undefined;
        ccEnableArenas?: boolean | undefined;
        objcClassPrefix?: string | undefined;
        csharpNamespace?: string | undefined;
        swiftPrefix?: string | undefined;
        phpClassPrefix?: string | undefined;
        phpNamespace?: string | undefined;
        phpMetadataNamespace?: string | undefined;
        rubyPackage?: string | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        javaPackage?: string | undefined;
        javaOuterClassname?: string | undefined;
        javaMultipleFiles?: boolean | undefined;
        javaGenerateEqualsAndHash?: boolean | undefined;
        javaStringCheckUtf8?: boolean | undefined;
        optimizeFor?: FileOptions_OptimizeMode | undefined;
        goPackage?: string | undefined;
        ccGenericServices?: boolean | undefined;
        javaGenericServices?: boolean | undefined;
        pyGenericServices?: boolean | undefined;
        phpGenericServices?: boolean | undefined;
        deprecated?: boolean | undefined;
        ccEnableArenas?: boolean | undefined;
        objcClassPrefix?: string | undefined;
        csharpNamespace?: string | undefined;
        swiftPrefix?: string | undefined;
        phpClassPrefix?: string | undefined;
        phpNamespace?: string | undefined;
        phpMetadataNamespace?: string | undefined;
        rubyPackage?: string | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof FileOptions>, never>>(object: I): FileOptions;
};
export declare const MessageOptions: {
    typeUrl: string;
    encode(message: MessageOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MessageOptions;
    fromJSON(object: any): MessageOptions;
    toJSON(message: MessageOptions): unknown;
    fromPartial<I extends {
        messageSetWireFormat?: boolean | undefined;
        noStandardDescriptorAccessor?: boolean | undefined;
        deprecated?: boolean | undefined;
        mapEntry?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        messageSetWireFormat?: boolean | undefined;
        noStandardDescriptorAccessor?: boolean | undefined;
        deprecated?: boolean | undefined;
        mapEntry?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof MessageOptions>, never>>(object: I): MessageOptions;
};
export declare const FieldOptions: {
    typeUrl: string;
    encode(message: FieldOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): FieldOptions;
    fromJSON(object: any): FieldOptions;
    toJSON(message: FieldOptions): unknown;
    fromPartial<I extends {
        ctype?: FieldOptions_CType | undefined;
        packed?: boolean | undefined;
        jstype?: FieldOptions_JSType | undefined;
        lazy?: boolean | undefined;
        deprecated?: boolean | undefined;
        weak?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        ctype?: FieldOptions_CType | undefined;
        packed?: boolean | undefined;
        jstype?: FieldOptions_JSType | undefined;
        lazy?: boolean | undefined;
        deprecated?: boolean | undefined;
        weak?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof FieldOptions>, never>>(object: I): FieldOptions;
};
export declare const OneofOptions: {
    typeUrl: string;
    encode(message: OneofOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): OneofOptions;
    fromJSON(object: any): OneofOptions;
    toJSON(message: OneofOptions): unknown;
    fromPartial<I extends {
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, "uninterpretedOption">, never>>(object: I): OneofOptions;
};
export declare const EnumOptions: {
    typeUrl: string;
    encode(message: EnumOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): EnumOptions;
    fromJSON(object: any): EnumOptions;
    toJSON(message: EnumOptions): unknown;
    fromPartial<I extends {
        allowAlias?: boolean | undefined;
        deprecated?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        allowAlias?: boolean | undefined;
        deprecated?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof EnumOptions>, never>>(object: I): EnumOptions;
};
export declare const EnumValueOptions: {
    typeUrl: string;
    encode(message: EnumValueOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): EnumValueOptions;
    fromJSON(object: any): EnumValueOptions;
    toJSON(message: EnumValueOptions): unknown;
    fromPartial<I extends {
        deprecated?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        deprecated?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof EnumValueOptions>, never>>(object: I): EnumValueOptions;
};
export declare const ServiceOptions: {
    typeUrl: string;
    encode(message: ServiceOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ServiceOptions;
    fromJSON(object: any): ServiceOptions;
    toJSON(message: ServiceOptions): unknown;
    fromPartial<I extends {
        deprecated?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        deprecated?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof ServiceOptions>, never>>(object: I): ServiceOptions;
};
export declare const MethodOptions: {
    typeUrl: string;
    encode(message: MethodOptions, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MethodOptions;
    fromJSON(object: any): MethodOptions;
    toJSON(message: MethodOptions): unknown;
    fromPartial<I extends {
        deprecated?: boolean | undefined;
        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        deprecated?: boolean | undefined;
        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & Record<Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>, never>) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & Record<Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>, never>)[] & Record<Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: bigint | undefined;
            negativeIntValue?: bigint | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof MethodOptions>, never>>(object: I): MethodOptions;
};
export declare const UninterpretedOption: {
    typeUrl: string;
    encode(message: UninterpretedOption, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UninterpretedOption;
    fromJSON(object: any): UninterpretedOption;
    toJSON(message: UninterpretedOption): unknown;
    fromPartial<I extends {
        name?: {
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        }[] | undefined;
        identifierValue?: string | undefined;
        positiveIntValue?: bigint | undefined;
        negativeIntValue?: bigint | undefined;
        doubleValue?: number | undefined;
        stringValue?: Uint8Array | undefined;
        aggregateValue?: string | undefined;
    } & {
        name?: ({
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        }[] & ({
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        } & {
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        } & Record<Exclude<keyof I["name"][number], keyof UninterpretedOption_NamePart>, never>)[] & Record<Exclude<keyof I["name"], keyof {
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        }[]>, never>) | undefined;
        identifierValue?: string | undefined;
        positiveIntValue?: bigint | undefined;
        negativeIntValue?: bigint | undefined;
        doubleValue?: number | undefined;
        stringValue?: Uint8Array | undefined;
        aggregateValue?: string | undefined;
    } & Record<Exclude<keyof I, keyof UninterpretedOption>, never>>(object: I): UninterpretedOption;
};
export declare const UninterpretedOption_NamePart: {
    typeUrl: string;
    encode(message: UninterpretedOption_NamePart, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UninterpretedOption_NamePart;
    fromJSON(object: any): UninterpretedOption_NamePart;
    toJSON(message: UninterpretedOption_NamePart): unknown;
    fromPartial<I extends {
        namePart?: string | undefined;
        isExtension?: boolean | undefined;
    } & {
        namePart?: string | undefined;
        isExtension?: boolean | undefined;
    } & Record<Exclude<keyof I, keyof UninterpretedOption_NamePart>, never>>(object: I): UninterpretedOption_NamePart;
};
export declare const SourceCodeInfo: {
    typeUrl: string;
    encode(message: SourceCodeInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): SourceCodeInfo;
    fromJSON(object: any): SourceCodeInfo;
    toJSON(message: SourceCodeInfo): unknown;
    fromPartial<I extends {
        location?: {
            path?: number[] | undefined;
            span?: number[] | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: string[] | undefined;
        }[] | undefined;
    } & {
        location?: ({
            path?: number[] | undefined;
            span?: number[] | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: string[] | undefined;
        }[] & ({
            path?: number[] | undefined;
            span?: number[] | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: string[] | undefined;
        } & {
            path?: (number[] & number[] & Record<Exclude<keyof I["location"][number]["path"], keyof number[]>, never>) | undefined;
            span?: (number[] & number[] & Record<Exclude<keyof I["location"][number]["span"], keyof number[]>, never>) | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: (string[] & string[] & Record<Exclude<keyof I["location"][number]["leadingDetachedComments"], keyof string[]>, never>) | undefined;
        } & Record<Exclude<keyof I["location"][number], keyof SourceCodeInfo_Location>, never>)[] & Record<Exclude<keyof I["location"], keyof {
            path?: number[] | undefined;
            span?: number[] | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: string[] | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, "location">, never>>(object: I): SourceCodeInfo;
};
export declare const SourceCodeInfo_Location: {
    typeUrl: string;
    encode(message: SourceCodeInfo_Location, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): SourceCodeInfo_Location;
    fromJSON(object: any): SourceCodeInfo_Location;
    toJSON(message: SourceCodeInfo_Location): unknown;
    fromPartial<I extends {
        path?: number[] | undefined;
        span?: number[] | undefined;
        leadingComments?: string | undefined;
        trailingComments?: string | undefined;
        leadingDetachedComments?: string[] | undefined;
    } & {
        path?: (number[] & number[] & Record<Exclude<keyof I["path"], keyof number[]>, never>) | undefined;
        span?: (number[] & number[] & Record<Exclude<keyof I["span"], keyof number[]>, never>) | undefined;
        leadingComments?: string | undefined;
        trailingComments?: string | undefined;
        leadingDetachedComments?: (string[] & string[] & Record<Exclude<keyof I["leadingDetachedComments"], keyof string[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof SourceCodeInfo_Location>, never>>(object: I): SourceCodeInfo_Location;
};
export declare const GeneratedCodeInfo: {
    typeUrl: string;
    encode(message: GeneratedCodeInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GeneratedCodeInfo;
    fromJSON(object: any): GeneratedCodeInfo;
    toJSON(message: GeneratedCodeInfo): unknown;
    fromPartial<I extends {
        annotation?: {
            path?: number[] | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        }[] | undefined;
    } & {
        annotation?: ({
            path?: number[] | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        }[] & ({
            path?: number[] | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        } & {
            path?: (number[] & number[] & Record<Exclude<keyof I["annotation"][number]["path"], keyof number[]>, never>) | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        } & Record<Exclude<keyof I["annotation"][number], keyof GeneratedCodeInfo_Annotation>, never>)[] & Record<Exclude<keyof I["annotation"], keyof {
            path?: number[] | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, "annotation">, never>>(object: I): GeneratedCodeInfo;
};
export declare const GeneratedCodeInfo_Annotation: {
    typeUrl: string;
    encode(message: GeneratedCodeInfo_Annotation, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GeneratedCodeInfo_Annotation;
    fromJSON(object: any): GeneratedCodeInfo_Annotation;
    toJSON(message: GeneratedCodeInfo_Annotation): unknown;
    fromPartial<I extends {
        path?: number[] | undefined;
        sourceFile?: string | undefined;
        begin?: number | undefined;
        end?: number | undefined;
    } & {
        path?: (number[] & number[] & Record<Exclude<keyof I["path"], keyof number[]>, never>) | undefined;
        sourceFile?: string | undefined;
        begin?: number | undefined;
        end?: number | undefined;
    } & Record<Exclude<keyof I, keyof GeneratedCodeInfo_Annotation>, never>>(object: I): GeneratedCodeInfo_Annotation;
};
